/**
 * <copyright>
 * </copyright>
 *
 * $Id: XmadslPageImpl.java 7486 2011-04-13 14:50:22Z hoenninger $
 */
package org.openxma.dsl.pom.model.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.openxma.dsl.dom.model.Dependant;
import org.openxma.dsl.pom.PomPackage;
import org.openxma.dsl.pom.model.CustomizationOfGuiElement;
import org.openxma.dsl.pom.model.LabelText;
import org.openxma.dsl.pom.model.LogicBlock;
import org.openxma.dsl.pom.model.ObjectProperty;
import org.openxma.dsl.pom.model.Page;
import org.openxma.dsl.pom.model.PageProperty;
import org.openxma.dsl.pom.model.XmadslPage;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Xmadsl Page</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslPageImpl#isAbstract <em>Abstract</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslPageImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslPageImpl#getLabelText <em>Label Text</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslPageImpl#getPageProperty <em>Page Property</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslPageImpl#getTemplate <em>Template</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslPageImpl#getDependencies <em>Dependencies</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslPageImpl#getPageProperties <em>Page Properties</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslPageImpl#getLogicBlock <em>Logic Block</em>}</li>
 *   <li>{@link org.openxma.dsl.pom.model.impl.XmadslPageImpl#getExtensions <em>Extensions</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class XmadslPageImpl extends PageImpl implements XmadslPage {
	/**
     * The default value of the '{@link #isAbstract() <em>Abstract</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #isAbstract()
     * @generated
     * @ordered
     */
	protected static final boolean ABSTRACT_EDEFAULT = false;

	/**
     * The cached value of the '{@link #isAbstract() <em>Abstract</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #isAbstract()
     * @generated
     * @ordered
     */
	protected boolean abstract_ = ABSTRACT_EDEFAULT;

	/**
     * The default value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getName()
     * @generated
     * @ordered
     */
	protected static final String NAME_EDEFAULT = null;

	/**
     * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getName()
     * @generated
     * @ordered
     */
	protected String name = NAME_EDEFAULT;

	/**
     * The cached value of the '{@link #getLabelText() <em>Label Text</em>}' containment reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getLabelText()
     * @generated
     * @ordered
     */
	protected LabelText labelText;

	/**
     * The cached value of the '{@link #getPageProperty() <em>Page Property</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getPageProperty()
     * @generated
     * @ordered
     */
	protected EList<PageProperty> pageProperty;

	/**
     * The cached value of the '{@link #getTemplate() <em>Template</em>}' reference.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getTemplate()
     * @generated
     * @ordered
     */
	protected Page template;

	/**
     * The cached value of the '{@link #getDependencies() <em>Dependencies</em>}' reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getDependencies()
     * @generated
     * @ordered
     */
	protected EList<Dependant> dependencies;

	/**
     * The cached value of the '{@link #getPageProperties() <em>Page Properties</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getPageProperties()
     * @generated
     * @ordered
     */
	protected EList<ObjectProperty> pageProperties;

	/**
     * The cached value of the '{@link #getLogicBlock() <em>Logic Block</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getLogicBlock()
     * @generated
     * @ordered
     */
    protected LogicBlock logicBlock;

    /**
     * The cached value of the '{@link #getExtensions() <em>Extensions</em>}' containment reference list.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getExtensions()
     * @generated
     * @ordered
     */
	protected EList<CustomizationOfGuiElement> extensions;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected XmadslPageImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return PomPackage.Literals.XMADSL_PAGE;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public boolean isAbstract() {
        return abstract_;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setAbstract(boolean newAbstract) {
        boolean oldAbstract = abstract_;
        abstract_ = newAbstract;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_PAGE__ABSTRACT, oldAbstract, abstract_));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public Page getTemplate() {
        if (template != null && template.eIsProxy()) {
            InternalEObject oldTemplate = (InternalEObject)template;
            template = (Page)eResolveProxy(oldTemplate);
            if (template != oldTemplate) {
                if (eNotificationRequired())
                    eNotify(new ENotificationImpl(this, Notification.RESOLVE, PomPackage.XMADSL_PAGE__TEMPLATE, oldTemplate, template));
            }
        }
        return template;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public Page basicGetTemplate() {
        return template;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setTemplate(Page newTemplate) {
        Page oldTemplate = template;
        template = newTemplate;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_PAGE__TEMPLATE, oldTemplate, template));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<Dependant> getDependencies() {
        if (dependencies == null) {
            dependencies = new EObjectResolvingEList<Dependant>(Dependant.class, this, PomPackage.XMADSL_PAGE__DEPENDENCIES);
        }
        return dependencies;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<ObjectProperty> getPageProperties() {
        if (pageProperties == null) {
            pageProperties = new EObjectContainmentEList<ObjectProperty>(ObjectProperty.class, this, PomPackage.XMADSL_PAGE__PAGE_PROPERTIES);
        }
        return pageProperties;
    }

	/**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public LogicBlock getLogicBlock() {
        return logicBlock;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NotificationChain basicSetLogicBlock(LogicBlock newLogicBlock, NotificationChain msgs) {
        LogicBlock oldLogicBlock = logicBlock;
        logicBlock = newLogicBlock;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_PAGE__LOGIC_BLOCK, oldLogicBlock, newLogicBlock);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setLogicBlock(LogicBlock newLogicBlock) {
        if (newLogicBlock != logicBlock) {
            NotificationChain msgs = null;
            if (logicBlock != null)
                msgs = ((InternalEObject)logicBlock).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_PAGE__LOGIC_BLOCK, null, msgs);
            if (newLogicBlock != null)
                msgs = ((InternalEObject)newLogicBlock).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_PAGE__LOGIC_BLOCK, null, msgs);
            msgs = basicSetLogicBlock(newLogicBlock, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_PAGE__LOGIC_BLOCK, newLogicBlock, newLogicBlock));
    }

    /**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<CustomizationOfGuiElement> getExtensions() {
        if (extensions == null) {
            extensions = new EObjectContainmentEList<CustomizationOfGuiElement>(CustomizationOfGuiElement.class, this, PomPackage.XMADSL_PAGE__EXTENSIONS);
        }
        return extensions;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case PomPackage.XMADSL_PAGE__LABEL_TEXT:
                return basicSetLabelText(null, msgs);
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTY:
                return ((InternalEList<?>)getPageProperty()).basicRemove(otherEnd, msgs);
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTIES:
                return ((InternalEList<?>)getPageProperties()).basicRemove(otherEnd, msgs);
            case PomPackage.XMADSL_PAGE__LOGIC_BLOCK:
                return basicSetLogicBlock(null, msgs);
            case PomPackage.XMADSL_PAGE__EXTENSIONS:
                return ((InternalEList<?>)getExtensions()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getName() {
        return name;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setName(String newName) {
        String oldName = name;
        name = newName;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_PAGE__NAME, oldName, name));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public LabelText getLabelText() {
        return labelText;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetLabelText(LabelText newLabelText, NotificationChain msgs) {
        LabelText oldLabelText = labelText;
        labelText = newLabelText;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_PAGE__LABEL_TEXT, oldLabelText, newLabelText);
            if (msgs == null) msgs = notification; else msgs.add(notification);
        }
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setLabelText(LabelText newLabelText) {
        if (newLabelText != labelText) {
            NotificationChain msgs = null;
            if (labelText != null)
                msgs = ((InternalEObject)labelText).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_PAGE__LABEL_TEXT, null, msgs);
            if (newLabelText != null)
                msgs = ((InternalEObject)newLabelText).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - PomPackage.XMADSL_PAGE__LABEL_TEXT, null, msgs);
            msgs = basicSetLabelText(newLabelText, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, PomPackage.XMADSL_PAGE__LABEL_TEXT, newLabelText, newLabelText));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public EList<PageProperty> getPageProperty() {
        if (pageProperty == null) {
            pageProperty = new EObjectContainmentEList<PageProperty>(PageProperty.class, this, PomPackage.XMADSL_PAGE__PAGE_PROPERTY);
        }
        return pageProperty;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case PomPackage.XMADSL_PAGE__ABSTRACT:
                return isAbstract();
            case PomPackage.XMADSL_PAGE__NAME:
                return getName();
            case PomPackage.XMADSL_PAGE__LABEL_TEXT:
                return getLabelText();
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTY:
                return getPageProperty();
            case PomPackage.XMADSL_PAGE__TEMPLATE:
                if (resolve) return getTemplate();
                return basicGetTemplate();
            case PomPackage.XMADSL_PAGE__DEPENDENCIES:
                return getDependencies();
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTIES:
                return getPageProperties();
            case PomPackage.XMADSL_PAGE__LOGIC_BLOCK:
                return getLogicBlock();
            case PomPackage.XMADSL_PAGE__EXTENSIONS:
                return getExtensions();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case PomPackage.XMADSL_PAGE__ABSTRACT:
                setAbstract((Boolean)newValue);
                return;
            case PomPackage.XMADSL_PAGE__NAME:
                setName((String)newValue);
                return;
            case PomPackage.XMADSL_PAGE__LABEL_TEXT:
                setLabelText((LabelText)newValue);
                return;
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTY:
                getPageProperty().clear();
                getPageProperty().addAll((Collection<? extends PageProperty>)newValue);
                return;
            case PomPackage.XMADSL_PAGE__TEMPLATE:
                setTemplate((Page)newValue);
                return;
            case PomPackage.XMADSL_PAGE__DEPENDENCIES:
                getDependencies().clear();
                getDependencies().addAll((Collection<? extends Dependant>)newValue);
                return;
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTIES:
                getPageProperties().clear();
                getPageProperties().addAll((Collection<? extends ObjectProperty>)newValue);
                return;
            case PomPackage.XMADSL_PAGE__LOGIC_BLOCK:
                setLogicBlock((LogicBlock)newValue);
                return;
            case PomPackage.XMADSL_PAGE__EXTENSIONS:
                getExtensions().clear();
                getExtensions().addAll((Collection<? extends CustomizationOfGuiElement>)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case PomPackage.XMADSL_PAGE__ABSTRACT:
                setAbstract(ABSTRACT_EDEFAULT);
                return;
            case PomPackage.XMADSL_PAGE__NAME:
                setName(NAME_EDEFAULT);
                return;
            case PomPackage.XMADSL_PAGE__LABEL_TEXT:
                setLabelText((LabelText)null);
                return;
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTY:
                getPageProperty().clear();
                return;
            case PomPackage.XMADSL_PAGE__TEMPLATE:
                setTemplate((Page)null);
                return;
            case PomPackage.XMADSL_PAGE__DEPENDENCIES:
                getDependencies().clear();
                return;
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTIES:
                getPageProperties().clear();
                return;
            case PomPackage.XMADSL_PAGE__LOGIC_BLOCK:
                setLogicBlock((LogicBlock)null);
                return;
            case PomPackage.XMADSL_PAGE__EXTENSIONS:
                getExtensions().clear();
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case PomPackage.XMADSL_PAGE__ABSTRACT:
                return abstract_ != ABSTRACT_EDEFAULT;
            case PomPackage.XMADSL_PAGE__NAME:
                return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
            case PomPackage.XMADSL_PAGE__LABEL_TEXT:
                return labelText != null;
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTY:
                return pageProperty != null && !pageProperty.isEmpty();
            case PomPackage.XMADSL_PAGE__TEMPLATE:
                return template != null;
            case PomPackage.XMADSL_PAGE__DEPENDENCIES:
                return dependencies != null && !dependencies.isEmpty();
            case PomPackage.XMADSL_PAGE__PAGE_PROPERTIES:
                return pageProperties != null && !pageProperties.isEmpty();
            case PomPackage.XMADSL_PAGE__LOGIC_BLOCK:
                return logicBlock != null;
            case PomPackage.XMADSL_PAGE__EXTENSIONS:
                return extensions != null && !extensions.isEmpty();
        }
        return super.eIsSet(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (abstract: ");
        result.append(abstract_);
        result.append(", name: ");
        result.append(name);
        result.append(')');
        return result.toString();
    }

} //XmadslPageImpl
